std::codecvt< char16_t, char, mbstate_t > Class Referenceabstract
Inheritance diagram for std::codecvt< char16_t, char, mbstate_t >:
[legend]

## Public Types

typedef char | extern_type
typedef char16_t | intern_type
typedef codecvt_base::result | result
typedef mbstate_t | state_type

## Public Member Functions

| codecvt (size_t __refs=0)
bool | always_noconv () const throw ()
int | encoding () const throw ()
result | in (state_type &__state, const extern_type *__from, const extern_type *__from_end, const extern_type *&__from_next, intern_type *__to, intern_type *__to_end, intern_type *&__to_next) const
int | length (state_type &__state, const extern_type *__from, const extern_type *__end, size_t __max) const
int | max_length () const throw ()
result | out (state_type &__state, const intern_type *__from, const intern_type *__from_end, const intern_type *&__from_next, extern_type *__to, extern_type *__to_end, extern_type *&__to_next) const
result | unshift (state_type &__state, extern_type *__to, extern_type *__to_end, extern_type *&__to_next) const

## Static Public Attributes

static locale::id | id

## Protected Member Functions

virtual bool | do_always_noconv () const throw ()
virtual bool | do_always_noconv () const=0 throw ()
virtual int | do_encoding () const throw ()
virtual int | do_encoding () const=0 throw ()
virtual result | do_in (state_type &__state, const extern_type *__from, const extern_type *__from_end, const extern_type *&__from_next, intern_type *__to, intern_type *__to_end, intern_type *&__to_next) const
virtual int | do_length (state_type &, const extern_type *__from, const extern_type *__end, size_t __max) const
virtual int | do_max_length () const throw ()
virtual int | do_max_length () const=0 throw ()
virtual result | do_out (state_type &__state, const intern_type *__from, const intern_type *__from_end, const intern_type *&__from_next, extern_type *__to, extern_type *__to_end, extern_type *&__to_next) const
virtual result | do_unshift (state_type &__state, extern_type *__to, extern_type *__to_end, extern_type *&__to_next) const

## Static Protected Member Functions

static __c_locale | _S_clone_c_locale (__c_locale &__cloc) throw ()
static void | _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
static void | _S_destroy_c_locale (__c_locale &__cloc)
static __c_locale | _S_get_c_locale ()
static const char * | _S_get_c_name () throw ()
static __c_locale | _S_lc_ctype_c_locale (__c_locale __cloc, const char *__s)

## Detailed Description

Class codecvt<char16_t, char, mbstate_t> specialization.

Converts between UTF-16 and UTF-8.

Definition at line 468 of file codecvt.h.

## Member Function Documentation

## do_out()

virtual result std::codecvt< char16_t, char, mbstate_t >::do_out | ( | state_type & | __state,
|  | const intern_type * | __from,
|  | const intern_type * | __from_end,
|  | const intern_type *& | __from_next,
|  | extern_type * | __to,
|  | extern_type * | __to_end,
|  | extern_type *& | __to_next
| ) |  | const

protected virtual

Convert from internal to external character set.

Converts input string of intern_type to output string of extern_type. This function is a hook for derived classes to change the value returned.

See also
  out for more information.

Implements std::__codecvt_abstract_base< char16_t, char, mbstate_t >.

## in()

result std::__codecvt_abstract_base< char16_t , char , mbstate_t >::in | ( | state_type & | __state,
|  | const extern_type * | __from,
|  | const extern_type * | __from_end,
|  | const extern_type *& | __from_next,
|  | intern_type * | __to,
|  | intern_type * | __to_end,
|  | intern_type *& | __to_next
| ) |  | const

inline inherited

Convert from external to internal character set.

Converts input string of extern_type to output string of intern_type. This is analogous to mbsrtowcs. It does this by calling codecvt::do_in.

The source and destination character sets are determined by the facet's locale, internal and external types.

The characters in [from,from_end) are converted and written to [to,to_end). from_next and to_next are set to point to the character following the last successfully converted character, respectively. If the result needed no conversion, from_next and to_next are not affected.

The state argument should be initialized if the input is at the beginning and carried from a previous call if continuing conversion. There are no guarantees about how state is used.

The result returned is a member of codecvt_base::result. If all the input is converted, returns codecvt_base::ok. If no conversion is necessary, returns codecvt_base::noconv. If the input ends early or there is insufficient space in the output, returns codecvt_base::partial. Otherwise the conversion failed and codecvt_base::error is returned.

Parameters

  __state | Persistent conversion state data.
  __from | Start of input.
  __from_end | End of input.
  __from_next | Returns start of unconverted data.
  __to | Start of output buffer.
  __to_end | End of output buffer.
  __to_next | Returns start of unused output area.

Returns
  codecvt_base::result.

Definition at line 196 of file codecvt.h.

## out()

result std::__codecvt_abstract_base< char16_t , char , mbstate_t >::out | ( | state_type & | __state,
|  | const intern_type * | __from,
|  | const intern_type * | __from_end,
|  | const intern_type *& | __from_next,
|  | extern_type * | __to,
|  | extern_type * | __to_end,
|  | extern_type *& | __to_next
| ) |  | const

inline inherited

Convert from internal to external character set.

Converts input string of intern_type to output string of extern_type. This is analogous to wcsrtombs. It does this by calling codecvt::do_out.

The source and destination character sets are determined by the facet's locale, internal and external types.

The characters in [from,from_end) are converted and written to [to,to_end). from_next and to_next are set to point to the character following the last successfully converted character, respectively. If the result needed no conversion, from_next and to_next are not affected.

The state argument should be initialized if the input is at the beginning and carried from a previous call if continuing conversion. There are no guarantees about how state is used.

The result returned is a member of codecvt_base::result. If all the input is converted, returns codecvt_base::ok. If no conversion is necessary, returns codecvt_base::noconv. If the input ends early or there is insufficient space in the output, returns codecvt_base::partial. Otherwise the conversion failed and codecvt_base::error is returned.

Parameters

  __state | Persistent conversion state data.
  __from | Start of input.
  __from_end | End of input.
  __from_next | Returns start of unconverted data.
  __to | Start of output buffer.
  __to_end | End of output buffer.
  __to_next | Returns start of unused output area.

Returns
  codecvt_base::result.

Definition at line 116 of file codecvt.h.

## unshift()

result std::__codecvt_abstract_base< char16_t , char , mbstate_t >::unshift | ( | state_type & | __state,
|  | extern_type * | __to,
|  | extern_type * | __to_end,
|  | extern_type *& | __to_next
| ) |  | const

inline inherited

Reset conversion state.

Writes characters to output that would restore state to initial conditions. The idea is that if a partial conversion occurs, then the converting the characters written by this function would leave the state in initial conditions, rather than partial conversion state. It does this by calling codecvt::do_unshift().

For example, if 4 external characters always converted to 1 internal character, and input to in() had 6 external characters with state saved, this function would write two characters to the output and set the state to initialized conditions.

The source and destination character sets are determined by the facet's locale, internal and external types.

The result returned is a member of codecvt_base::result. If the state could be reset and data written, returns codecvt_base::ok. If no conversion is necessary, returns codecvt_base::noconv. If the output has insufficient space, returns codecvt_base::partial. Otherwise the reset failed and codecvt_base::error is returned.

Parameters

  __state | Persistent conversion state data.
  __to | Start of output buffer.
  __to_end | End of output buffer.
  __to_next | Returns start of unused output area.

Returns
  codecvt_base::result.

Definition at line 155 of file codecvt.h.

The documentation for this class was generated from the following file:

- codecvt.h